#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#define CELLA 30
#define RIGHE 200
#define COLONNE 10
#define MAX 50

//scorre tutta la matrice e la riempie di 0
void pulisciMatrice(char matrice[RIGHE][COLONNE][CELLA]){
	int riga, colonna, i;
	for(riga = 0; riga < RIGHE; riga++){
		for(colonna = 0; colonna < COLONNE; colonna++){
			for(i = 0; i < CELLA; i++){
				matrice[riga][colonna][i] = 0;
			}
		}
	}
}

/*
void stampaMatrice(char matrice[RIGHE][COLONNE][CELLA]){
	int riga, colonna, i;
	for(riga = 0; riga < RIGHE; riga++){
		for(colonna = 0; colonna < COLONNE; colonna++){
			for(i = 0; matrice[riga][colonna][i] != '\0'; i++){
				printf("%c", matrice[riga][colonna][i]);
			}
			printf(" ");
		}
		printf("\n");
	}
}
*/

//scorre la stringa e se contiene un numero restituisce 1
int verificaStringa(char stringa[]){
	int i, isdig = 0;
	for(  ; stringa[i] != '\0'; i++){
		if(isdigit(stringa[i])){
			isdig = 1;
		}
	}
	return isdig;
}

//stampa l'elenco degli alunni
void stampaTabella(char matrice[RIGHE][COLONNE][CELLA], int lunghezza){
	int riga = 0;
	printf("  N |     Cognome     |         Nome         | Sesso | Provincia | Numero esami | Media esami\n");
	for( ; riga < lunghezza; riga++){
		printf("%3d | %15s | %20s | %5s | %9s | %12s | %11s\n", riga+1, matrice[riga][0], matrice[riga][1],
															matrice[riga][2], matrice[riga][3], 
															matrice[riga][4], matrice[riga][5]);
	}
}

//scorre la stringa contente un numero e se c'e' un carattere restituisce 0
int verificaNumeroStringa(char stringa[]){
	int i = 0;
	int isdig = 1;
	for( ; stringa[i] != '\0'; i++){
		if(!isdigit(stringa[i])){
			isdig = 0;
		}
	}
	return isdig;
}

//scorre la stringa e la riempie di 0
void pulisciStringa(char stringa[]){
	int i;
	for(i = 0; stringa[i] != '\0'; i++){
		stringa[i] = 0;
	}
}

//scorre la stringa e strasforma ogni carattere in maiuscolo
void maiuscolo(char stringa[]){
	int i;
	for(i = 0; stringa[i] != '\0'; i++){
		stringa[i] = toupper(stringa[i]);
	}
}

//scambia due righe della matrice
void scambio(char matrice[RIGHE][COLONNE][CELLA], int indice1, int indice2){
	char dep[CELLA];	//variabile deposito
	int i;
	for(i = 0; i < COLONNE; i++){
		strcpy(dep, matrice[indice1][i]);
		strcpy(matrice[indice1][i], matrice[indice2][i]);
		strcpy(matrice[indice2][i], dep);
		pulisciStringa(dep);
	}
}

//mette in ordine alfabetico la matrice
void ordineAlfabetico(char matrice[RIGHE][COLONNE][CELLA], int colonna, int lunghezza){
	int i, minimo, j;
	//una specie di select sort
	for(i = 0; i < lunghezza; i++){
		for(minimo = i, j = i; j < lunghezza; j++){	//prende come riferimento la prima stringa della sottomatrice
			if(strcmp(matrice[minimo][colonna], matrice[j][colonna]) > 0){	//e la confronta con le altre
				minimo = j;		//nel caso in cui la stringa confrontata avesse un valore minore cambia
			}
		}
		scambio(matrice, minimo, i);	//alla fine si scambiano di posto la prima stringa della sottomatrice e la stringa con valore minore
	}
}

//mette in ordine decrescente i valori numerici
void ordineDecrescente(char matrice[RIGHE][COLONNE][CELLA], int colonna, int lunghezza){
	int i, massimo, j;
	//una specie di select sort in cui i piu' grandi vengono messi per primi
	for(i = 0; i < lunghezza; i++){
		for(massimo = i, j = i; j < lunghezza; j++){
			if(atoi(matrice[massimo][colonna]) < atoi(matrice[j][colonna])){ //atoi restituisce l'int del numero passato come stringa
				massimo = j;
			}
		}
		scambio(matrice, massimo, i);
	}
}

/*
void rimuovi(char matrice[RIGHE][COLONNE][CELLA] ,int lunghezza){
	char dep[1][50][50];
	char cognome[30];
	char risultato[30];
	char copia[30];
	int i,j,len;
	len=lunghezza-1;
	printf("Cognome dello studente che vuoi eliminare: ");
	scanf("%s",cognome);
	maiuscolo(cognome);
	for(i=0;lunghezza>i;i++){
		strcpy(copia,matrice[i][0]);
		if (strcmp(copia,cognome)==0){
			for(j=0;j<6;j++){
				strcpy(dep[0][j],matrice[i][j]);
				strcpy(matrice[i][j],matrice[len][j]);
				strcpy(matrice[len][j],dep[0][j]);
			}	
		}
	}		
}
*/


void rimuovi(char matrice[RIGHE][COLONNE][CELLA], int lunghezza){
	int i, j;
	int lunghezzaTrovati = 0;
	int isdig = 0;
	char cognome[CELLA];
	char trovati[RIGHE][COLONNE][CELLA]; //matrice di appoggio
	int indiciTrovati[RIGHE];
	int scelta = 1;
	int rigaDaEliminare;
	char conferma;
	pulisciMatrice(trovati);
	printf("\nInserisci il cognome dello studente da eliminare: ");
	scanf("%s", cognome);
	isdig = verificaStringa(cognome);
	while(isdig){
		printf("\nInput non valido.\n\n");
		printf("Riprova: ");
		scanf("%s",cognome);
		isdig = verificaStringa(cognome);
	}
	maiuscolo(cognome);
	//cerca il cognome inserito
	for(i = 0; i < lunghezza; i++){
		if(!strcmp(matrice[i][0], cognome)){
			for(j = 0; j < 5; j++){
				strcpy(trovati[lunghezzaTrovati][j], matrice[i][j]);	//e quando trova una corrispondenza lo aggiunge alla matrice di appoggio
			}
			indiciTrovati[lunghezzaTrovati] = i;
			lunghezzaTrovati++;
		}
	}
	if(lunghezzaTrovati == 0){
		printf("\nNessuno studente trovato.\n");
	}else{
		stampaTabella(trovati, lunghezzaTrovati);
		//se viene trovata piu' di una corrispondenza fa scegliere quale eliminare
		if(lunghezzaTrovati > 1){
			printf("\nQuale vuoi eliminare? [0 = annulla]: ");
			scanf("%d", &scelta);
			while(scelta < 0 || scelta > lunghezzaTrovati){
				printf("\nInput non valido.\n\n");
				printf("Riprova: ");
				scanf("%d", &scelta);
			}
		}
		printf("Confermi l'eliminazione? [s/n]: ");
		scanf(" %c", &conferma);
		if(scelta && (conferma == 's' || conferma == 'S')){
			rigaDaEliminare = indiciTrovati[scelta-1];
			for(i = 0; i < 5; i++){
				pulisciStringa(matrice[rigaDaEliminare][i]);
			}
			for(i = rigaDaEliminare; i < lunghezza; i++){
				strcpy(matrice[i][0], matrice[i+1][0]);
				strcpy(matrice[i][1], matrice[i+1][1]);
				strcpy(matrice[i][2], matrice[i+1][2]);
				strcpy(matrice[i][3], matrice[i+1][3]);
				strcpy(matrice[i][4], matrice[i+1][4]);
				strcpy(matrice[i][5], matrice[i+1][5]);
			}
			printf("\nStudente eliminato!\n\n");
		}else{
			printf("\nAnnullo...\n\n");
		}
	}
}


