/*
Programma per la gestione di studenti in memoria.
L'elenco di studenti sar inserito in memoria manualmente

1) Aggiungi studente all'elenco
2) Modifica studente
3) Cancella studente
4) Visualizza studenti
*/


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "modulo.h"
#include "html.h"


int main(){
	FILE *fr;	//puntatore al file
	char line[MAX];	//linea che viene letta
	char *dato;	//singolo dato
	char matrice[RIGHE][COLONNE][CELLA];	//elenco degli studenti
	char cognome[CELLA];
	char nome[CELLA];
	char provincia[3];
	char sesso[2];
	char nEsami[3];
	char mediaEsami[3];
	int i = 0;
	int riga = 0;
	int colonna = 0;
	int len;
	int scelta;
	int run = 1;
	int isdig = 0;
	int ordina;
	int lunghezzaMatrice;
	
	pulisciMatrice(matrice);
	
	//apertura file, se c'e' un errore esce dal programma
	if((fr = fopen("STUDENTI.csv", "r")) == NULL){
		printf("\nErrore nell'apertura del file \"STUDENTI.csv\"\n");
		exit(1);
	}
	while(fgets(line, MAX, fr) != NULL){	//legge linea del file e verifica se  vuota
		len = strlen(line);		//calcola la lunghezza della stringa
		line[len-1] = '\0';		//sostituisce  \n con il terminatore
		dato = strtok(line, ",");	//spezza la linea
		while(dato != NULL){
			strcpy(matrice[riga][colonna], dato);	//copia il dato nella cella della matrice
			dato = strtok(NULL, ",");	//legge il dato dopo
			colonna++;
		}
		colonna = 0;
		riga++;
	}
	
	lunghezzaMatrice = riga;
	

	while(run){
		printf("\n");
		printf("1. Aggiungi studente\n");
		printf("2. Rimuovi studente\n");
		printf("3. Modifica studente\n");
		printf("4. Ordina studenti\n");
		printf("5. Visualizza studenti\n");
		printf("6. Stampa tabella HTML\n");
		printf("0. Esci\n\n");
		printf("Cosa vuoi fare? ");
		scanf("%d", &scelta);
		
		if(scelta == 0){
			run = 0;
		}else if(scelta == 1){
			printf("Inserisci i dati dello studente.\n\n");
			printf("Inserisci il cognome: ");
			scanf("%s", cognome);
			isdig = verificaStringa(cognome);
			while(isdig){
				printf("\nInput non valido.\n\n");
				printf("Riprova: ");
				scanf("%s",cognome);
				isdig = verificaStringa(cognome);
			}
			
			printf("Inserisci il nome: ");
			scanf("%s", nome);
			isdig = verificaStringa(nome);
			while(isdig){
				printf("\nInput non valido.\n\n");
				printf("Riprova: ");
				scanf("%s",nome);
				isdig = verificaStringa(nome);
			}
			
			printf("Inserisci il sesso: ");
			scanf("%s", sesso);
			isdig = verificaStringa(sesso);
			while(isdig || (strcmp(sesso, "M") && strcmp(sesso, "m") && strcmp(sesso, "F") && strcmp(sesso, "f"))){
				printf("\nInput non valido.\n\n");
				printf("Riprova: ");
				scanf("%s", sesso);
				isdig = verificaStringa(sesso);
			}
			
			printf("Inserisci la provincia: ");
			scanf("%s", provincia);
			isdig = verificaStringa(provincia);
			while(isdig || strlen(provincia) != 2){
				printf("\nInput non valido.\n\n");
				printf("Riprova: ");
				scanf("%s", provincia);
				isdig = verificaStringa(provincia);
			}
			
			printf("Inserisci il numero di esami: ");
			scanf("%s", nEsami);
			isdig = verificaNumeroStringa(nEsami);
			while(!isdig || atoi(nEsami) < 0 ){
				printf("\nInput non valido.\n\n");
				printf("Riprova: ");
				scanf("%s", nEsami);
				isdig = verificaNumeroStringa(nEsami);	
			}
			
			printf("Inserire la media esami: ");
			scanf("%s", mediaEsami);
			isdig = verificaNumeroStringa(mediaEsami);
			while(!isdig || atoi(mediaEsami) < 0 || atoi(mediaEsami) > 30){
				printf("\nInput non valido.\n\n");
				printf("Riprova: ");
				scanf("%s",mediaEsami);
				isdig = verificaNumeroStringa(mediaEsami);	
			}
			
			maiuscolo(cognome);
			maiuscolo(nome);
			maiuscolo(provincia);
			maiuscolo(sesso);
			
			strcpy(matrice[lunghezzaMatrice][0],cognome);
			strcpy(matrice[lunghezzaMatrice][1],nome);
			strcpy(matrice[lunghezzaMatrice][2],sesso);
			strcpy(matrice[lunghezzaMatrice][3],provincia);
			strcpy(matrice[lunghezzaMatrice][4],nEsami);
			strcpy(matrice[lunghezzaMatrice][5],mediaEsami);
			lunghezzaMatrice++;
		}else if(scelta == 2){
			rimuovi(matrice, lunghezzaMatrice);
			lunghezzaMatrice--;
		}else if(scelta == 3){
			printf("\nInserire i dati dello studente da modificare.\n\n");
			printf("Cognome: ");
			scanf("%s",cognome);
			isdig=verificaStringa(cognome);
		
			while(isdig){
				printf("\nInput non valido.\n\n");
				printf("Riprova: ");
				scanf("%s",cognome);
				isdig=verificaStringa(cognome);
			}
		
			printf("Nome: ");
			scanf("%s",nome);
			isdig=verificaStringa(nome);
		
			while(isdig){
				printf("Riprova: ");
				scanf("%s",nome);
				isdig=verificaStringa(nome);
			}
			
			maiuscolo(cognome);
			maiuscolo(nome);
		
			for(i = 0; i < lunghezzaMatrice; i++){
				if((!strcmp(matrice[i][0],cognome)) && (!strcmp(matrice[i][1],nome))){
					printf("\n");
					printf("1. Cognome\n");
					printf("2. Nome\n");
					printf("3. Sesso\n");
					printf("4. Provincia\n");
					printf("5. Numero Esami\n");
					printf("6. Media Esami\n");
					printf("0. Indietro\n\n");
					printf("Cosa vuoi modificare? ");
					scanf("%d", &scelta);
					
					if(scelta == 0){
						i = lunghezzaMatrice;
					}else if(scelta == 1){
						pulisciStringa(matrice[i][0]);
						printf("Inserire il cognome: ");
						scanf("%s", cognome);
						isdig = verificaStringa(cognome);
						while(isdig){
							printf("\nInput non valido.\n\n");
							printf("Riprova: ");
							scanf("%s", cognome);
							isdig = verificaStringa(cognome);
						}
						maiuscolo(cognome);
						strcpy(matrice[i][0], cognome);
					}else if(scelta == 2){
						pulisciStringa(matrice[i][1]);
						printf("Inserire il nome: ");
						scanf("%s", nome);
						isdig=verificaStringa(nome);
						while(isdig){
							printf("\nInput non valido.\n\n");
							printf("Riprova: ");
							scanf("%s", nome);
							isdig = verificaStringa(nome);
						}
						maiuscolo(nome);
						strcpy(matrice[i][1], nome);
					}else if(scelta == 3){
						pulisciStringa(matrice[i][2]);
						printf("Inserire il sesso: ");
						scanf("%s", sesso);
						isdig=verificaStringa(sesso);
						while(isdig){
							printf("\nInput non valido.\n\n");
							printf("Riprova: ");
							scanf("%s", sesso);
							isdig = verificaStringa(sesso);
						}
						maiuscolo(sesso);
						strcpy(matrice[i][2],sesso);
					}else if(scelta == 4){
						pulisciStringa(matrice[i][3]);
						printf("Inserire la provincia: ");
						scanf("%s",provincia);
						isdig = verificaNumeroStringa(provincia);
						while(isdig){
							printf("\nInput non valido.\n\n");
							printf("Riprova: ");
							scanf("%s",provincia);
							isdig = verificaNumeroStringa(provincia);
						}
						maiuscolo(provincia);
						strcpy(matrice[i][3],provincia);
					}else if(scelta == 5){
						pulisciStringa(matrice[i][4]);
						printf("Inserire il numero di esami: ");
						scanf("%s",nEsami);
						isdig=verificaNumeroStringa(nEsami);
						while(isdig){
							printf("\nInput non valido.\n\n");
							printf("Riprova: ");
							scanf("%s",nEsami);
							isdig = verificaNumeroStringa(nEsami);
						}
						strcpy(matrice[i][4],nEsami);
					}else if(scelta == 6){
						pulisciStringa(matrice[i][5]);
						printf("Inserire la media esami: ");
						scanf("%s",mediaEsami);
						isdig=verificaNumeroStringa(mediaEsami);
						while(isdig){
							printf("\nInput non valido.\n\n");
							printf("Riprova: ");
							scanf("%s",mediaEsami);
							isdig = verificaNumeroStringa(mediaEsami);
						}
						strcpy(matrice[i][5],mediaEsami);
					}
				}
			}
		}else if(scelta == 4){
			ordina = 1;
			while(ordina){
				printf("\n");
				printf("1. Ordinare per cognome\n");
				printf("2. Ordinare per nome\n");
				printf("3. Ordinare per provincia\n");
				printf("4. Ordinare per numero esami\n");
				printf("5. Ordinare per media\n");
				printf("0. Indietro\n\n");
				printf("Cosa vuoi fare? ");
				scanf("%d", &scelta);
				
				if(scelta == 0){
					ordina = 0;
				}else if(scelta == 1){
					ordineAlfabetico(matrice, 0, lunghezzaMatrice);
					ordina = 0;
				}else if(scelta == 2){
					ordineAlfabetico(matrice, 1, lunghezzaMatrice);
					ordina = 0;
				}else if(scelta == 3){
					ordineAlfabetico(matrice, 3, lunghezzaMatrice);
					ordina = 0;
				}else if(scelta == 4){
					ordineDecrescente(matrice, 4, lunghezzaMatrice);
					ordina = 0;
				}else if(scelta == 5){
					ordineDecrescente(matrice, 5, lunghezzaMatrice);
					ordina = 0;
				}
			}
		}else if(scelta == 5){
			stampaTabella(matrice, lunghezzaMatrice);
		}else if(scelta == 6){
			FILE *fw;
			fw = fopen("studenti.html", "w");
			htmlinizio(fw);
			htmltable(fw, '1');
			for(riga = 0; riga < lunghezzaMatrice; riga++){
				htmlcellnum(fw, riga+1);
				htmlcell(fw, matrice[riga][0]);
				htmlcell(fw, matrice[riga][1]);
				htmlcell(fw, matrice[riga][2]);
				htmlcell(fw, matrice[riga][3]);
				htmlcell(fw, matrice[riga][4]);
				htmlcell(fw, matrice[riga][5]);
				htmlrow(fw);
			}
			fclose(fw);
		}
	}
	fclose(fr);
	return 0;
}
